const {_psj }    =require("nv-facutil-promise");
const { Client } = require('ssh2');
const creat_path_cache = require("./path-cache").creat;
const _parse_rslt      = require("./parse-rslt");

const creat_cfg_tmpl = ()=>({
    host: '127.0.0.1',
    port: 22,
    username: 'root',
    password: 'your-pass' ,
    //privateKey: readFileSync('/path/to/my/key')    
});

const fmt_cfg = (cfg)=> {
    let ncfg = creat_cfg_tmpl();
    Object.assign(ncfg,cfg);
    if(ncfg.privateKey) {
        delete ncfg.password
    } else {}
    return(ncfg)    
}


class C  {
    path = creat_path_cache();
    #cfg = creat_cfg_tmpl();
    #client  = new Client();
    #streams = []
    get c_()            {return(this.#client)}
    get streams_()      {return(this.#streams)}
    _ainit(cfg=creat_cfg_tmpl()) {
         cfg = fmt_cfg(cfg);
         this.#cfg = cfg;
         let [p,rs,rj] = _psj();
         let c = this.#client
         c.on('ready', () => {rs(true)});
         c.on('error', (err) => {rj(err)});
         c.connect(cfg)
         return(p)
    }
    _asend(cmd) {
         let c = this.#client;
         let [p,rs,rj] = _psj();
         c.exec(
            cmd,  
            (err, stream) => {
                  if (err) {
                     rj(err)
                  } else {
                     this.#streams.push(stream);
                     rs(stream);
                  }
            }
         );
         return(p)
    }
    _arecv(decd=(buf)=>buf.toString("utf8")) {
         let stream = this.#streams.shift();
         let [p,rs,rj] = _psj();
         let  buf = Buffer.alloc(0);
         stream.on(
             'close', 
              (code, signal) => {
                 if(code === 0) {
                    rs(decd(buf))
                 } else {
                    rj({code,signal})
                 }
             }
         ).on(
            'data', 
            (data) => {
               buf =  Buffer.concat([buf,data])
            }
         ).stderr.on(
            'data', 
            (data) => {
                rj(data.toString());
            }
         );    
         return(p)         
    }
    async _fetch(cmd,decd=(buf)=>buf.toString("utf8")) {
       await this._asend(cmd);
       return(await this._arecv())
    }
    _quit() {
        this.#client.end()
    }
    get [Symbol.toStringTag]() {
        return(JSON.stringify(this.#cfg,null,2))
    }   
    ////
    async cd(p="./") {
	let oldp = this.path.p;
	p = this.path.cd(p);
	let cmd = `cd ${JSON.stringify(p)}\n`;
	try        {
	   await this._fetch(cmd);
	} catch(e) {
	    console.log(e.message);
	    this.path.cd(oldp);
	    p = oldp;
	}
	return(p);
    }
    pwd() {return(this.path.p)}
    async ls()  {
	let p = this.path.p;
	let cmd = `cd ${JSON.stringify(p)}\n   ls -al\n`;
	let s = await this._fetch(cmd);
        let rslt = _parse_rslt.ls_al(s,p);
	return(rslt)
    }
    async fetch(cmd, input_fmt=(r)=>r,     output_fmt=(r)=>r) {
        let p = this.path.p;
	cmd   = `cd ${JSON.stringify(p)}\n   ${input_fmt(cmd)}\n`;
	let s = await this._fetch(cmd);
        let rslt = output_fmt(s,p);
        return(rslt)	
    }
}

const creat = async (cfg=creat_cfg_tmpl()) => {
   let c = new C();
   await c._ainit(cfg);
   c.path.cd("/");
   return(c)
}

const login_with_name_and_passwd = async(host,uname,upass,port=22)=> await creat({host,port,username:uname,password:upass});

module.exports = {
   creat,
   login_with_name_and_passwd,
}
